package rule

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	"errors"
	"github.com/jinzhu/copier"
	"time"
	"xorm.io/xorm"
)

func AddOrder(eg *xorm.Engine, req map[string]string) {
	max := db.GetMaxPrice(eg, req["uid"])
	one, _ := db.SysCfgGetOne(eg, "capital_pool_mul")
	var capitalPoolMul float64 = 0
	if one != nil {
		capitalPoolMul = zhios_order_relate_utils.StrToFloat64(one.Val)
	}
	req["price"] = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(req["price"])*capitalPoolMul, 2)
	if req["type"] == "mall_goods_user_lv" {
		for i := 0; i < zhios_order_relate_utils.StrToInt(req["num"]); i++ {
			var data = &model.MallOrdCapitalPoolTotal{
				Uid:        zhios_order_relate_utils.StrToInt(req["uid"]),
				Price:      req["price"],
				LeavePrice: req["price"],
				Num:        1,
				UpdateTime: time.Now(),
				Oid:        req["oid"],
				Type:       1,
			}
			eg.Insert(data)
		}
	} else {
		if max != nil {
			max.LeavePrice = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(max.LeavePrice)+zhios_order_relate_utils.StrToFloat64(req["price"]), 3)
			max.OtherPrice = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(max.OtherPrice)+zhios_order_relate_utils.StrToFloat64(req["price"]), 3)
			max.UpdateTime = time.Now()
			eg.Where("id=?", max.Id).Update(max)
		}
	}
}

func Pool(eg *xorm.Engine, price string) error {
	if zhios_order_relate_utils.StrToFloat64(price) == 0 {
		return errors.New("没有可分配金额")
	}
	session := eg.NewSession()
	defer session.Close()
	err := session.Begin()
	if err != nil {
		session.Rollback()
		return err
	}
	pool, err := db.GetNewCapitalPoolSess(session)
	if err != nil || pool.Id == 0 {
		session.Rollback()
		return errors.New("没有记录")
	}
	if pool.IsUse == 0 {
		session.Rollback()

		return errors.New("没有开启")
	}
	poolBonus := db.GetBonusValueAndCoin(session, &pool, price)
	if poolBonus == nil {
		session.Rollback()

		return errors.New("没有可分配金额")
	}
	//生成分红记录初始数据
	var bonus model.NewCapitalPoolBonus
	bonus.BonusType = 2
	bonus.CreateAt = time.Now()
	bonus.BonusValue = price
	if poolBonus.BonusValue-poolBonus.OldBonusValue > 0 {
		bonus.OutBonusValue = zhios_order_relate_utils.AnyToString(poolBonus.BonusValue - poolBonus.OldBonusValue)
	}
	one, err := session.InsertOne(&bonus)
	if err != nil || one == 0 {
		session.Rollback()
		return errors.New("失败")
	}
	//统计数量
	//礼包的
	sql := `SELECT SUM(num) as sum,uid FROM mall_ord_capital_pool_total WHERE leave_price>0 and type=1 GROUP BY uid;`
	nativeString, err := db.QueryNativeStringSess(session, sql)
	if err != nil {
		session.Rollback()

		return err
	}
	sqlFirst := `SELECT uid FROM mall_ord_capital_pool_total WHERE  type=0 GROUP BY uid;`
	nativeStringFirst, errFirst := db.QueryNativeStringSess(session, sqlFirst)
	if errFirst != nil {
		session.Rollback()

		return err
	}
	sum := 0
	ids := make([]string, 0)
	newIds := make([]string, 0)
	//礼包的算份数
	for _, v := range nativeString {
		sum += zhios_order_relate_utils.StrToInt(v["sum"])
		ids = append(ids, v["uid"])
	}
	//非礼包的 站位
	for _, v := range nativeStringFirst {
		if zhios_order_relate_utils.InArr(v["uid"], ids) == false || len(ids) == 0 {
			sum += 1
			newIds = append(newIds, v["uid"])
		}
	}
	if sum == 0 {
		session.Rollback()
		return errors.New("没有分配份数")
	}
	oneMoney := zhios_order_relate_utils.StrToFloat64(price) / float64(sum)
	//金额小的先扣 扣不完 给下一个
	var userMap = make(map[string]float64)
	var userSumMap = make(map[string]float64)
	for _, v := range ids {
		//读取用户的记录
		var leave float64 = 0
		var data []model.MallOrdCapitalPoolTotal
		err := session.Where("uid=? and type=? and leave_price>?", v, 1, 0).Find(&data)
		if err != nil {
			session.Rollback()
			return err
		}
		for _, v1 := range data {
			userSumMap[v] += oneMoney
			leave, err = OneDoing(session, v1, oneMoney, leave)
			if err != nil {
				session.Rollback()
				return err
			}
		}
		//这里判断下有没有初始记录有金额 如果没有的话就进入损失金额
		if leave > 0 {
			var oneData model.MallOrdCapitalPoolTotal
			has, err := session.Where("uid=? and type=? ", v, 0).Get(&oneData)
			if err != nil {
				session.Rollback()
				return err
			}
			if has && zhios_order_relate_utils.StrToFloat64(oneData.LeavePrice) > 0 {
				//先扣除  剩下的进损失
				if zhios_order_relate_utils.StrToFloat64(oneData.LeavePrice)-leave < 0 {
					leave = leave - zhios_order_relate_utils.StrToFloat64(oneData.LeavePrice)
					oneData.LeavePrice = "0"
				} else {
					oneData.LeavePrice = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(oneData.LeavePrice)-leave, 2)
					leave = 0
				}
				update, err := session.Where("id=?", oneData.Id).Cols("leave_price").Update(&oneData)
				if update == 0 || err != nil {
					session.Rollback()
					return err
				}
			}
			//剩下的进损失
			err = db.InsertCapitalPoolLossMoney(session, v, zhios_order_relate_utils.Float64ToStrByPrec(leave, 3), "分红损失", "0", "capital_pool")
			if err != nil {
				session.Rollback()
				return err
			}
			userSumMap[v] -= leave
			leave = 0
		}
		userMap[v] = leave
	}
	for _, v := range nativeStringFirst {
		var leave float64 = 0
		money, ok := userMap[v["uid"]]
		if ok {
			leave = money
		}
		if zhios_order_relate_utils.InArr(v["uid"], ids) == false || len(ids) == 0 {
			userSumMap[v["uid"]] += oneMoney
			var oneData model.MallOrdCapitalPoolTotal
			_, err := session.Where("uid=? and type=? ", v["uid"], 0).Get(&oneData)
			if err != nil {
				session.Rollback()
				return err
			}
			//这里还能分
			leave, err = OneDoing(session, oneData, oneMoney, leave)
			if err != nil {
				session.Rollback()
				return err
			}
		} else {
			//这里只需要判断要不要扣  多出的进入损失金额
			if leave > 0 {
				var oneData model.MallOrdCapitalPoolTotal
				has, err := session.Where("uid=? and type=? ", v, 0).Get(&oneData)
				if err != nil {
					session.Rollback()
					return err
				}
				if has && zhios_order_relate_utils.StrToFloat64(oneData.LeavePrice) > 0 {
					//先扣除  剩下的进损失
					if zhios_order_relate_utils.StrToFloat64(oneData.LeavePrice)-leave < 0 {
						leave = leave - zhios_order_relate_utils.StrToFloat64(oneData.LeavePrice)
						oneData.LeavePrice = "0"
					} else {
						leave = 0
						oneData.LeavePrice = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(oneData.LeavePrice)-leave, 2)
					}
					update, err := session.Where("id=?", oneData.Id).Cols("leave_price").Update(&oneData)
					if update == 0 || err != nil {
						session.Rollback()
						return err
					}
				}
			}
		}
		if leave > 0 {
			//剩下的进损失
			err = db.InsertCapitalPoolLossMoney(session, v["uid"], zhios_order_relate_utils.Float64ToStrByPrec(leave, 3), "分红损失", "0", "capital_pool")
			if err != nil {
				session.Rollback()
				return err
			}
			userSumMap[v["uid"]] -= leave
		}
	}
	var RealBonusValue float64 = 0
	for k, v := range userSumMap {
		if v <= 0 {
			continue
		}
		bools := Finflow(session, k, v)
		if bools == false {
			session.Rollback()
			return errors.New("失败")
		}
		RealBonusValue += v
	}
	bonus.RealBonusValue = zhios_order_relate_utils.Float64ToStrByPrec(RealBonusValue, 2)
	bonus.LossBonusValue = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(price)-RealBonusValue, 2)
	bonus.BonusUserNum = zhios_order_relate_utils.IntToStr(sum)
	bonus.BonusUserRecord = zhios_order_relate_utils.SerializeStr(userSumMap)
	bonus.BonusPeriod = bonus.Id
	update, err := session.ID(bonus.Id).Update(&bonus)
	if err != nil || update == 0 {
		session.Rollback()
		return errors.New("失败")
	}
	session.Commit()
	return nil
}
func OneDoing(sess *xorm.Session, data model.MallOrdCapitalPoolTotal, oneMoney, leave float64) (float64, error) {
	money := oneMoney + leave
	if zhios_order_relate_utils.StrToFloat64(data.LeavePrice) <= 0 {
		return money, nil
	}
	if zhios_order_relate_utils.StrToFloat64(data.LeavePrice)-money < 0 {
		leave = money - zhios_order_relate_utils.StrToFloat64(data.LeavePrice)
		data.LeavePrice = "0"
	} else {
		leave = 0
		data.LeavePrice = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.StrToFloat64(data.LeavePrice)-money, 2)
	}
	update, err := sess.Where("id=?", data.Id).Cols("leave_price").Update(&data)
	if update == 0 || err != nil {
		return leave, errors.New("失败")
	}
	return leave, nil
}

func AddBonusOrd(engine *xorm.Engine, t *md.BonusOrdParam) error {

	//获取分红基础设置
	pool, err := db.GetNewCapitalPool(engine)
	if err != nil || pool.Id == 0 {
		return errors.New("分红设置有误")
	}
	if pool.IsUse == 0 {
		return errors.New("功能没有开始使用，插入分红失败")
	}
	var capitalPoolOrd model.NewCapitalPoolOrd
	copier.Copy(&capitalPoolOrd, &t)
	capitalPoolOrd.Uid = zhios_order_relate_utils.StrToInt(t.Uid)
	capitalPoolOrd.OrdId = zhios_order_relate_utils.AnyToInt64(t.OrdId)
	capitalPoolOrd.CreateAt = time.Now()
	capitalPoolOrd.UpdateAt = time.Now()
	capitalPoolOrd.SettleCardinality = pool.SettleCardinality
	if pool.SettleCardinality == "price" { //价格为基数
		capitalPoolOrd.DepositValue = t.PriceValue
		capitalPoolOrd.Commission = t.PriceValue
	}
	one, err := engine.InsertOne(&capitalPoolOrd)
	if err != nil || one == 0 {
		if err == nil {
			err = errors.New("插入数据有误！")
		}
		return err
	}
	return nil
}

func Finflow(session *xorm.Session, uid string, amount float64) bool {
	beforeAmount := "0"
	afterAmount := "0"
	var affected int64 = 0
	userProfile, err := db.UserProfileFindByIDWithSession(session, uid)

	if err != nil || userProfile == nil {
		return false
	}
	now := time.Now()
	ItemTitle := "消费补贴"
	finUserFlow := model.FinUserFlow{
		Type:         0,
		Uid:          zhios_order_relate_utils.StrToInt(uid),
		Amount:       zhios_order_relate_utils.Float64ToStrByPrec(amount, 9),
		BeforeAmount: beforeAmount,
		AfterAmount:  afterAmount,
		OrdType:      "self_buy_capital_pool",
		OrdId:        "",
		OrdAction:    104,
		OrdDetail:    "",
		State:        2,
		OrdTitle:     ItemTitle,
		CreateAt:     now,
		UpdateAt:     now,
	}

	// 更新用户余额
	finUserFlow.BeforeAmount = userProfile.FinValid
	userProfile.FinValid = zhios_order_relate_utils.Float64ToStrByPrec(zhios_order_relate_utils.AnyToFloat64(userProfile.FinValid)+zhios_order_relate_utils.AnyToFloat64(amount), 9)
	userProfile.FinTotal = userProfile.FinTotal + zhios_order_relate_utils.StrToFloat32(zhios_order_relate_utils.Float64ToStrByPrec(amount, 9))
	affected, err = db.UserProfileUpdateWithSession(session, uid, userProfile, "fin_total", "fin_valid")
	finUserFlow.AfterAmount = userProfile.FinValid
	has, errs := db.InsertCommWithSession(
		session, &finUserFlow)
	if affected == 0 || err != nil || errs != nil || has == 0 {
		return false
	}
	return true
}
